diff --git a/web/pgadmin/static/js/components/CodeMirror.jsx b/web/pgadmin/static/js/components/CodeMirror.jsx
index 7e3c0cdda..de891d62b 100644
--- a/web/pgadmin/static/js/components/CodeMirror.jsx
+++ b/web/pgadmin/static/js/components/CodeMirror.jsx
@@ -8,11 +8,11 @@
 //////////////////////////////////////////////////////////////
 
 import React, { useEffect, useMemo, useRef, useState } from 'react';
-import {default as OrigCodeMirror} from 'bundled_codemirror';
+import OrigCodeMirror from 'bundled_codemirror';
 import {useOnScreen} from 'sources/custom_hooks';
 import PropTypes from 'prop-types';
 import CustomPropTypes from '../custom_prop_types';
-import pgAdmin from 'sources/pgadmin';
+import pgWindow from 'sources/window';
 import gettext from 'sources/gettext';
 import { Box, InputAdornment, makeStyles } from '@material-ui/core';
 import clsx from 'clsx';
@@ -31,6 +31,11 @@ const useStyles = makeStyles((theme)=>({
   root: {
     position: 'relative',
   },
+  hideCursor: {
+    '& .CodeMirror-cursors': {
+      display: 'none'
+    }
+  },
   findDialog: {
     position: 'absolute',
     zIndex: 99,
@@ -70,31 +75,40 @@ function parseQuery(query, useRegex=false, matchCase=false) {
   return query;
 }
 
+function getRegexFinder(query) {
+  return (stream) => {
+    query.lastIndex = stream.pos;
+    var match = query.exec(stream.string);
+    if (match && match.index == stream.pos) {
+      stream.pos += match[0].length || 1;
+      return 'searching';
+    } else if (match) {
+      stream.pos = match.index;
+    } else {
+      stream.skipToEnd();
+    }
+  };
+}
+
+
+function getPlainStringFinder(query, matchCase) {
+  return (stream) => {
+    var matchIndex = (matchCase ? stream.string :  stream.string.toLowerCase()).indexOf(query, stream.pos);
+    if(matchIndex == -1) {
+      stream.skipToEnd();
+    } else if(matchIndex == stream.pos) {
+      stream.pos += query.length;
+      return 'searching';
+    } else {
+      stream.pos = matchIndex;
+    }
+  };
+}
+
 function searchOverlay(query, matchCase) {
   return {
     token: typeof query == 'string' ?
-      (stream) =>{
-        var matchIndex = (matchCase ? stream.string :  stream.string.toLowerCase()).indexOf(query, stream.pos);
-        if(matchIndex == -1) {
-          stream.skipToEnd();
-        } else if(matchIndex == stream.pos) {
-          stream.pos += query.length;
-          return 'searching';
-        } else {
-          stream.pos = matchIndex;
-        }
-      } : (stream) => {
-        query.lastIndex = stream.pos;
-        var match = query.exec(stream.string);
-        if (match && match.index == stream.pos) {
-          stream.pos += match[0].length || 1;
-          return 'searching';
-        } else if (match) {
-          stream.pos = match.index;
-        } else {
-          stream.skipToEnd();
-        }
-      }
+      getPlainStringFinder(query, matchCase) : getRegexFinder(query)
   };
 }
 
@@ -260,28 +274,96 @@ FindDialog.propTypes = {
   onClose: PropTypes.func,
 };
 
+function handleDrop(editor, e) {
+  var dropDetails = null;
+  try {
+    dropDetails = JSON.parse(e.dataTransfer.getData('text'));
+
+    /* Stop firefox from redirecting */
+
+    if(e.preventDefault) {
+      e.preventDefault();
+    }
+    if (e.stopPropagation) {
+      e.stopPropagation();
+    }
+  } catch(error) {
+    /* if parsing fails, it must be the drag internal of codemirror text */
+    return;
+  }
+
+  var cursor = editor.coordsChar({
+    left: e.x,
+    top: e.y,
+  });
+  editor.replaceRange(dropDetails.text, cursor);
+  editor.focus();
+  editor.setSelection({
+    ...cursor,
+    ch: cursor.ch + dropDetails.cur.from,
+  },{
+    ...cursor,
+    ch: cursor.ch +dropDetails.cur.to,
+  });
+}
+
+function calcFontSize(fontSize) {
+  if(fontSize) {
+    fontSize = parseFloat((Math.round(parseFloat(fontSize + 'e+2')) + 'e-2'));
+    let rounded = Number(fontSize);
+    if(rounded > 0) {
+      return rounded + 'em';
+    }
+  }
+  return '1em';
+}
+
 /* React wrapper for CodeMirror */
-export default function CodeMirror({currEditor, name, value, options, events, readonly, disabled, className}) {
+export default function CodeMirror({currEditor, name, value, options, events, readonly, disabled, className, autocomplete=false}) {
   const taRef = useRef();
   const editor = useRef();
   const cmWrapper = useRef();
   const isVisibleTrack = useRef();
   const classes = useStyles();
   const [[showFind, isReplace], setShowFind] = useState([false, false]);
-  const defaultOptions = {
-    tabindex: '0',
-    lineNumbers: true,
-    styleSelectedText: true,
-    mode: 'text/x-pgsql',
-    foldOptions: {
-      widget: '\u2026',
-    },
-    foldGutter: true,
-    gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter'],
-    extraKeys: pgAdmin.Browser.editor_shortcut_keys,
-    dragDrop: false,
-    screenReaderLabel: gettext('SQL editor'),
-  };
+  const defaultOptions = useMemo(()=>{
+    let goLeftKey = 'Ctrl-Alt-Left',
+      goRightKey = 'Ctrl-Alt-Right',
+      commentKey = 'Ctrl-/';
+    if(isMac()) {
+      goLeftKey = 'Cmd-Alt-Left';
+      goRightKey = 'Cmd-Alt-Right';
+      commentKey = 'Cmd-/';
+    }
+    return {
+      tabindex: '0',
+      lineNumbers: true,
+      styleSelectedText: true,
+      mode: 'text/x-pgsql',
+      foldOptions: {
+        widget: '\u2026',
+      },
+      foldGutter: true,
+      gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter'],
+      extraKeys: {
+        // Autocomplete sql command
+        ...(autocomplete ? {
+          'Ctrl-Space': 'autocomplete',
+        }: {}),
+        'Alt-Up': 'goLineUp',
+        'Alt-Down': 'goLineDown',
+        // Move word by word left/right
+        [goLeftKey]: 'goGroupLeft',
+        [goRightKey]: 'goGroupRight',
+        // Allow user to delete Tab(s)
+        'Shift-Tab': 'indentLess',
+        //comment
+        [commentKey]: 'toggleComment',
+      },
+      dragDrop: true,
+      screenReaderLabel: gettext('SQL editor'),
+    };
+  });
 
   useEffect(()=>{
     const finalOptions = {...defaultOptions, ...options};
@@ -317,29 +399,61 @@ export default function CodeMirror({currEditor, name, value, options, events, re
             setShowFind([false, false]);
             setShowFind([true, true]);
           }
-        }
+        },
+        'Cmd-G': false,
       });
     }
 
     Object.keys(events||{}).forEach((eventName)=>{
       editor.current.on(eventName, events[eventName]);
     });
-
+    editor.current.on('drop', handleDrop);
+    initPreferences();
     return ()=>{
       editor.current?.toTextArea();
     };
   }, []);
 
+  const initPreferences = ()=>{
+    reflectPreferences();
+    pgWindow?.pgAdmin?.Browser?.onPreferencesChange('sqleditor', function() {
+      reflectPreferences();
+    });
+  };
+
+  const reflectPreferences = ()=>{
+    let pref = pgWindow?.pgAdmin?.Browser?.get_preferences_for_module('sqleditor') || {};
+    let wrapEle = editor?.current.getWrapperElement();
+    wrapEle && (wrapEle.style.fontSize = calcFontSize(pref.sql_font_size));
+
+    if(pref.plain_editor_mode) {
+      editor?.current.setOption('mode', 'text/plain');
+      /* Although not required, setting explicitly as codemirror will remove code folding only on next edit */
+      editor?.current.setOption('foldGutter', false);
+    } else {
+      editor?.current.setOption('mode', 'text/x-pgsql');
+      editor?.current.setOption('foldGutter', pref.code_folding);
+    }
+
+    editor?.current.setOption('indentWithTabs', pref.indent_with_tabs);
+    editor?.current.setOption('indentUnit', pref.tab_size);
+    editor?.current.setOption('tabSize', pref.tab_size);
+    editor?.current.setOption('lineWrapping', pref.wrap_code);
+    editor?.current.setOption('autoCloseBrackets', pref.insert_pair_brackets);
+    editor?.current.setOption('matchBrackets', pref.brace_matching);
+    editor?.current.refresh();
+  };
+
   useEffect(()=>{
     if(editor.current) {
       if(disabled) {
-        cmWrapper.current.classList.add('cm_disabled');
-        editor.current.setOption('readOnly', 'nocursor');
+        editor.current.setOption('readOnly', true);
+        cmWrapper.current.classList.add(classes.hideCursor);
       } else if(readonly) {
-        cmWrapper.current.classList.add('cm_disabled');
         editor.current.setOption('readOnly', true);
         editor.current.addKeyMap({'Tab': false});
         editor.current.addKeyMap({'Shift-Tab': false});
+        cmWrapper.current.classList.add(classes.hideCursor);
       } else {
         cmWrapper.current.classList.remove('cm_disabled');
         editor.current.setOption('readOnly', false);
@@ -392,4 +506,5 @@ CodeMirror.propTypes = {
   readonly: PropTypes.bool,
   disabled: PropTypes.bool,
   className: CustomPropTypes.className,
+  autocomplete: PropTypes.bool,
 };
diff --git a/web/pgadmin/static/js/components/ExternalIcon.jsx b/web/pgadmin/static/js/components/ExternalIcon.jsx
index 2c6433764..3fa91b895 100644
--- a/web/pgadmin/static/js/components/ExternalIcon.jsx
+++ b/web/pgadmin/static/js/components/ExternalIcon.jsx
@@ -22,17 +22,16 @@ ExternalIcon.propTypes = {
   Icon: PropTypes.elementType.isRequired,
 };
 
-export const QueryToolIcon = ()=><ExternalIcon Icon={QueryToolSvg} style={{height: '0.7em'}} />;
-export const SaveDataIcon = ()=><ExternalIcon Icon={SaveDataSvg} style={{height: '0.7em'}} />;
+export const QueryToolIcon = ()=><ExternalIcon Icon={QueryToolSvg} style={{height: '1rem'}} />;
+export const SaveDataIcon = ()=><ExternalIcon Icon={SaveDataSvg} style={{height: '1rem'}} />;
 export const PasteIcon = ()=><ExternalIcon Icon={PasteSvg} />;
 export const FilterIcon = ()=><ExternalIcon Icon={FilterSvg} />;
 export const CommitIcon = ()=><ExternalIcon Icon={CommitSvg} />;
 export const RollbackIcon = ()=><ExternalIcon Icon={RollbackSvg} />;
 export const ClearIcon = ()=><ExternalIcon Icon={ClearSvg} />;
-export const ConnectedIcon = ()=><ExternalIcon Icon={ConnectedSvg} style={{height: '0.7em'}} />;
-export const DisonnectedIcon = ()=><ExternalIcon Icon={DisconnectedSvg} style={{height: '0.7em'}} />;
+export const ConnectedIcon = ()=><ExternalIcon Icon={ConnectedSvg} style={{height: '1rem'}} />;
+export const DisonnectedIcon = ()=><ExternalIcon Icon={DisconnectedSvg} style={{height: '1rem'}} />;
 export const RegexIcon = ()=><ExternalIcon Icon={RegexSvg} />;
 export const FormatCaseIcon = ()=><ExternalIcon Icon={FormatCaseSvg} />;
-export const ExpandDialogIcon = ()=><ExternalIcon Icon={Expand} style={{height: '1.2em'}}  />;
-export const MinimizeDialogIcon = ()=><ExternalIcon Icon={Collapse} style={{height: '1.4em'}} />;
-
+export const ExpandDialogIcon = ()=><ExternalIcon Icon={Expand} style={{height: '1.2rem'}}  />;
+export const MinimizeDialogIcon = ()=><ExternalIcon Icon={Collapse} style={{height: '1.4rem'}} />;
diff --git a/web/pgadmin/static/js/components/FormComponents.jsx b/web/pgadmin/static/js/components/FormComponents.jsx
index 1e425215c..cec2ae439 100644
--- a/web/pgadmin/static/js/components/FormComponents.jsx
+++ b/web/pgadmin/static/js/components/FormComponents.jsx
@@ -207,6 +207,7 @@ FormInputSQL.propTypes = {
   helpMessage: PropTypes.string,
   testcid: PropTypes.string,
   value: PropTypes.string,
+  controlProps: PropTypes.object,
   noLabel: PropTypes.bool,
   change: PropTypes.func,
 };
@@ -570,7 +571,7 @@ export function InputRadio({ helpid, value, onChange, controlProps, readonly, ..
           disableRipple
           {...props}
         />
-          
+
       }
       label={controlProps.label}
       className={(readonly || props.disabled) ? classes.readOnlySwitch : null}
@@ -821,6 +822,7 @@ export const InputSelect = forwardRef(({
   const [[finalOptions, isLoading], setFinalOptions] = useState([[], true]);
   const theme = useTheme();
 
+
   /* React will always take options var as changed parameter. So,
   We cannot run the below effect with options dependency as it will keep on
   loading the options. optionsReloadBasis is helpful to avoid repeated
@@ -1174,20 +1176,21 @@ const useStylesFormFooter = makeStyles((theme) => ({
 }));
 
 /* The form footer used mostly for showing error */
-export function FormFooterMessage(props) {
+export function FormFooterMessage({style, ...props}) {
   const classes = useStylesFormFooter();
 
   if (!props.message) {
     return <></>;
   }
   return (
-    <Box className={classes.root}>
+    <Box className={classes.root} style={style}>
       <NotifierMessage {...props}></NotifierMessage>
     </Box>
   );
 }
 
 FormFooterMessage.propTypes = {
+  style: PropTypes.object,
   message: PropTypes.string,
 };
 
diff --git a/web/pgadmin/static/js/components/JsonEditor.jsx b/web/pgadmin/static/js/components/JsonEditor.jsx
index ef7b910d7..3dae7df05 100644
--- a/web/pgadmin/static/js/components/JsonEditor.jsx
+++ b/web/pgadmin/static/js/components/JsonEditor.jsx
@@ -13,7 +13,7 @@ import PropTypes from 'prop-types';
 import CustomPropTypes from '../custom_prop_types';
 
 /* React wrapper for JsonEditor */
-export default function JsonEditor({currEditor, value, options, className}) {
+export default function JsonEditor({getEditor, value, options, className}) {
   const eleRef = useRef();
   const editor = useRef();
   const defaultOptions = {
@@ -34,9 +34,10 @@ export default function JsonEditor({currEditor, value, options, className}) {
       }
     });
     editor.current.setText(value);
-    currEditor && currEditor(editor.current);
+    getEditor?.(editor.current);
     editor.current.focus();
-    return ()=>editor.current?.destroy();
+    /* Required by json editor */
+    eleRef.current.style.height = eleRef.current.offsetHeight + 'px';
   }, []);
 
   useMemo(() => {
@@ -53,7 +54,7 @@ export default function JsonEditor({currEditor, value, options, className}) {
 }
 
 JsonEditor.propTypes = {
-  currEditor: PropTypes.func,
+  getEditor: PropTypes.func,
   value: PropTypes.string,
   options: PropTypes.object,
   className: CustomPropTypes.className,
diff --git a/web/pgadmin/static/js/components/Menu.jsx b/web/pgadmin/static/js/components/Menu.jsx
index 2920d678d..02b3e0b3c 100644
--- a/web/pgadmin/static/js/components/Menu.jsx
+++ b/web/pgadmin/static/js/components/Menu.jsx
@@ -18,6 +18,9 @@ const useStyles = makeStyles((theme)=>({
     '& .szh-menu': {
       padding: '4px 0px',
       zIndex: 1000,
+      backgroundColor: theme.palette.background.default,
+      color: theme.palette.text.primary,
+      border: `1px solid ${theme.otherVars.borderColor}`
     },
     '& .szh-menu__divider': {
       margin: 0,
diff --git a/web/pgadmin/static/js/components/ShortcutTitle.jsx b/web/pgadmin/static/js/components/ShortcutTitle.jsx
index 6ef1a564e..d822f3d5e 100644
--- a/web/pgadmin/static/js/components/ShortcutTitle.jsx
+++ b/web/pgadmin/static/js/components/ShortcutTitle.jsx
@@ -4,8 +4,13 @@ import PropTypes from 'prop-types';
 import { isMac } from '../keyboard_shortcuts';
 import _ from 'lodash';
 import CustomPropTypes from '../custom_prop_types';
+import gettext from 'sources/gettext';
 
 const useStyles = makeStyles((theme)=>({
+  shortcutTitle: {
+    width: '100%',
+    textAlign: 'center',
+  },
   shortcut: {
     justifyContent: 'center',
     marginTop: '0.125rem',
@@ -19,10 +24,43 @@ const useStyles = makeStyles((theme)=>({
   },
 }));
 
+export function getBrowserAccesskey() {
+  /* Ref: https://github.com/tillsanders/access-key-label-polyfill/ */
+  let ua = window.navigator.userAgent;
+  // macOS
+  if (ua.match(/macintosh/i)) {
+    // Firefox
+    if (ua.match(/firefox/i)) {
+      const firefoxVersion = ua.match(/firefox[\s/](\d+)/i);
+      // Firefox < v14
+      if (firefoxVersion[1] && parseInt(firefoxVersion[1], 10) < 14) {
+        return ['Ctrl'];
+      }
+    }
+    return ['Option', 'Ctrl'];
+  }
+
+  // Internet Explorer / Edge
+  if (ua.match(/msie|trident/i) || ua.match(/\sedg/i)) {
+    return ['Alt'];
+  }
+
+  // iOS / iPadOS
+  if (ua.match(/(ipod|iphone|ipad)/i)) {
+    // accesskeyLabel is supported > v14, but we're not checking for versions here, since we use
+    // feature support detection
+    return ['Option', 'Ctrl'];
+  }
+
+  // Fallback
+  // Note: Apparently, Chrome for Android is not even supporting accesskey, so be prepared.
+  return [gettext('Accesskey')];
+}
+
 export function shortcutToString(shortcut, accesskey=null, asArray=false) {
   let keys = [];
   if(accesskey) {
-    keys.push('Accesskey');
+    keys = getBrowserAccesskey();
     keys.push(_.capitalize(accesskey?.toUpperCase()));
   } else if(shortcut) {
     shortcut.alt && keys.push((isMac() ? 'Option' : 'Alt'));
@@ -41,12 +79,12 @@ export function shortcutToString(shortcut, accesskey=null, asArray=false) {
 }
 
 /* The tooltip content to show shortcut details */
-export default function ShortcutTitle({title, shortcut, accessKey}) {
+export default function ShortcutTitle({title, shortcut, accesskey}) {
   const classes = useStyles();
-  let keys = shortcutToString(shortcut, accessKey, true);
+  let keys = shortcutToString(shortcut, accesskey, true);
   return (
     <>
-      <div>{title}</div>
+      <div className={classes.shortcutTitle}>{title}</div>
       <div className={classes.shortcut}>
         {keys.map((key, i)=>{
           return <div key={i} className={classes.key}>{key}</div>;
@@ -59,5 +97,5 @@ export default function ShortcutTitle({title, shortcut, accessKey}) {
 ShortcutTitle.propTypes = {
   title: PropTypes.string,
   shortcut: CustomPropTypes.shortcut,
-  accessKey: PropTypes.string,
+  accesskey: PropTypes.string,
 };
diff --git a/web/pgadmin/static/js/custom_hooks.js b/web/pgadmin/static/js/custom_hooks.js
index b6370bbbe..a38088851 100644
--- a/web/pgadmin/static/js/custom_hooks.js
+++ b/web/pgadmin/static/js/custom_hooks.js
@@ -1,5 +1,6 @@
 import {useRef, useEffect, useState, useCallback} from 'react';
-export { useStopwatch } from 'react-timer-hook';
+import moment from 'moment';
+// export { useStopwatch } from 'react-timer-hook';
 
 /* React hook for setInterval */
 export function useInterval(callback, delay) {
@@ -78,6 +79,50 @@ export function useIsMounted() {
   return useCallback(() => ref.current, []);
 }
 
+export function useStopwatch() {
+  const prevTime = useRef(new Date());
+  const [totalMsec, setTotalMsec] = useState(0);
+  const [isRunning, setIsRunning] = useState(false);
+
+  useInterval(() => {
+    setTotalMsec(moment(new Date()).diff(prevTime.current));
+  }, isRunning ? 100 : -1);
+
+  function start(startTime) {
+    prevTime.current = startTime || new Date();
+    setIsRunning(true);
+  }
+
+  const pause = (endTime)=>{
+    setIsRunning(false);
+    setTotalMsec(moment(endTime || new Date()).diff(prevTime.current));
+  };
+
+  function reset() {
+    setTotalMsec(0);
+  }
+
+  let msec = totalMsec;
+  /* Extract seconds from millisecs */
+  let seconds = parseInt(msec/1000);
+  msec = msec%1000;
+
+  /* Extract mins from seconds */
+  let minutes = parseInt(seconds/60);
+  seconds = seconds%60;
+
+  /* Extract hrs from mins */
+  let hours = parseInt(minutes/60);
+  minutes = minutes%60;
+
+  return {
+    hours: hours,
+    minutes: minutes,
+    seconds: seconds,
+    msec: msec,
+    start, pause, reset, isRunning,
+  };
+}
 
 /*
   shortcuts = [
@@ -105,27 +150,30 @@ export function useKeyboardShortcuts(shortcuts, eleRef) {
   const matchFound = (shortcut, e)=>{
     if(!shortcut) return false;
     let keyCode = e.which || e.keyCode;
-    return shortcut.alt == e.altKey &&
-      shortcut.shift == e.shiftKey &&
-      shortcut.control == e.ctrlKey &&
+    return Boolean(shortcut.alt) == e.altKey &&
+      Boolean(shortcut.shift) == e.shiftKey &&
+      Boolean(shortcut.control) == e.ctrlKey &&
       shortcut.key.key_code == keyCode;
   };
   useEffect(()=>{
     let ele = eleRef.current ?? document;
-    const keyupCallback = (e)=>{
-      for(let i=0; i<(shortcutsRef.current??[]).length; i++){
-        let {shortcut, options} = shortcutsRef.current[i];
-        if(matchFound(shortcut, e)) {
-          if(options.callback && (options.enabled ?? true)) {
-            options.callback(e);
-          }
-          break;
+    const keydownCallback = (e)=>{
+      Promise.resolve(0).then(()=>{
+        let allListeners = _.filter(shortcutsRef.current, (s)=>matchFound(s.shortcut, e));
+        for(const {options} of allListeners) {
+          Promise.resolve(0).then(()=>{
+            if(options.callback && (options.enabled ?? true)) {
+              e.preventDefault();
+              e.stopPropagation();
+              options.callback(e);
+            }
+          });
         }
-      }
+      });
     };
-    ele.addEventListener('keyup', keyupCallback);
+    ele.addEventListener('keydown', keydownCallback);
     return ()=>{
-      ele.removeEventListener('keyup', keyupCallback);
+      ele.removeEventListener('keydown', keydownCallback);
     };
   }, [eleRef.current]);
 
diff --git a/web/pgadmin/static/js/custom_prop_types.js b/web/pgadmin/static/js/custom_prop_types.js
index 6ba21a6d3..1a2d4c935 100644
--- a/web/pgadmin/static/js/custom_prop_types.js
+++ b/web/pgadmin/static/js/custom_prop_types.js
@@ -31,9 +31,9 @@ const CustomPropTypes = {
   ]),
 
   shortcut: PropTypes.shape({
-    alt: PropTypes.bool,
-    control: PropTypes.bool,
-    shift: PropTypes.bool,
+    alt: PropTypes.oneOfType([PropTypes.bool, PropTypes.number]),
+    control: PropTypes.oneOfType([PropTypes.bool, PropTypes.number]),
+    shift: PropTypes.oneOfType([PropTypes.bool, PropTypes.number]),
     key: PropTypes.shape({
       char: PropTypes.string,
     }),
diff --git a/web/pgadmin/static/js/helpers/EventBus.js b/web/pgadmin/static/js/helpers/EventBus.js
index a9d077820..9a6906429 100644
--- a/web/pgadmin/static/js/helpers/EventBus.js
+++ b/web/pgadmin/static/js/helpers/EventBus.js
@@ -1,4 +1,3 @@
-import React from 'react';
 import _ from 'lodash';
 
 export default class EventBus {
@@ -6,11 +5,12 @@ export default class EventBus {
     this._eventListeners = [];
   }
 
-  registerListener(event, callback) {
+  registerListener(event, callback, once=false) {
     this._eventListeners = this._eventListeners || [];
     this._eventListeners.push({
       event: event,
       callback: callback,
+      fired: once ? 'pending' : 'ignore',
     });
   }
 
@@ -28,17 +28,19 @@ export default class EventBus {
   }
 
   fireEvent(event, ...args) {
+    let self = this;
     Promise.resolve(0).then(()=>{
       let allListeners = _.filter(this._eventListeners, (e)=>e.event==event);
       if(allListeners) {
         for(const listener of allListeners) {
           Promise.resolve(0).then(()=>{
             listener.callback(...args);
+            if(listener.fired == 'pending') {
+              self.deregisterListener(event, listener.callback);
+            }
           });
         }
       }
     });
   }
 }
-
-export const EventBusContext = React.createContext(new EventBus());
diff --git a/web/pgadmin/static/js/helpers/Layout.jsx b/web/pgadmin/static/js/helpers/Layout.jsx
index 5e3cbe9b0..5074024cc 100644
--- a/web/pgadmin/static/js/helpers/Layout.jsx
+++ b/web/pgadmin/static/js/helpers/Layout.jsx
@@ -1,8 +1,14 @@
-import React from 'react';
+import React, { useRef, useMemo } from 'react';
 import DockLayout from 'rc-dock';
 import { makeStyles } from '@material-ui/styles';
 import PropTypes from 'prop-types';
-import CustomPropTypes from '../custom_prop_types';
+import EventBus from './EventBus';
+import getApiInstance from '../api_instance';
+import url_for from 'sources/url_for';
+import { PgIconButton } from '../components/Buttons';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import gettext from 'sources/gettext';
+import {ExpandDialogIcon, MinimizeDialogIcon } from '../components/ExternalIcon';
 
 
 const useStyles = makeStyles((theme)=>({
@@ -26,10 +32,21 @@ const useStyles = makeStyles((theme)=>({
       paddingLeft: 0,
       backgroundColor: theme.palette.background.default,
       ...theme.mixins.panelBorder.bottom,
+      '& .dock-nav-wrap': {
+        cursor: 'move',
+      }
     },
     '& .dock-panel': {
       border: 'none',
+      '&.dragging': {
+        opacity: 0.6,
+        pointerEvents: 'visible',
+      },
+      '& .dock':  {
+        borderRadius: 'inherit',
+      },
       '&.dock-style-dialogs': {
+        borderRadius: theme.shape.borderRadius,
         '&.dock-panel.dragging': {
           opacity: 1,
         },
@@ -46,6 +63,10 @@ const useStyles = makeStyles((theme)=>({
             color: theme.palette.text.primary,
           }
         },
+      },
+      '& .dock-tabpane': {
+        backgroundColor: theme.palette.background.default,
+        color: theme.palette.text.primary,
       }
     },
     '& .dock-tab': {
@@ -54,10 +75,33 @@ const useStyles = makeStyles((theme)=>({
       marginRight: 0,
       background: 'unset',
       fontWeight: 'unset',
+      color: theme.palette.text.primary,
       '&::hover': {
         color: 'unset',
+      },
+      '& > div': {
+        padding: '4px 10px',
+      },
+      '& .drag-initiator': {
+        display: 'flex',
+        '& .dock-tab-close-btn': {
+          color: theme.palette.text.primary,
+          position: 'unset',
+          marginLeft: '8px',
+          fontSize: '18px',
+          transition: 'none',
+          '&::before': {
+            content: '"\\00d7"',
+            position: 'relative',
+            top: '-5px',
+          }
+        }
       }
     },
+    '& .dock-extra-content': {
+      alignItems: 'center',
+      paddingRight: '10px',
+    },
     '& .dock-vbox, & .dock-hbox .dock-vbox': {
       '& .dock-divider': {
         flexBasis: '1px',
@@ -91,25 +135,33 @@ const useStyles = makeStyles((theme)=>({
     },
     '& .dock-fbox': {
       zIndex: 1060,
+    },
+    '& .dock-mbox': {
+      zIndex: 1080,
+    },
+    '& .drag-accept-reject::after': {
+      content: '',
     }
   }
 }));
 
+export const LayoutEventsContext = React.createContext();
 
 export class LayoutHelper {
   static getPanel(attrs) {
     return {
       cached: true,
+      group: 'default',
       ...attrs,
     };
   }
 
   static close(docker, panelId) {
-    docker.dockMove(docker.find(panelId), 'remove');
+    docker?.dockMove(docker.find(panelId), 'remove');
   }
 
   static focus(docker, panelId) {
-    docker.updateTab(panelId, null, true);
+    docker?.updateTab(panelId, null, true);
   }
 
   static openDialog(docker, panelData, width=500, height=300) {
@@ -128,12 +180,16 @@ export class LayoutHelper {
         tabs: [LayoutHelper.getPanel({
           ...panelData,
           group: 'dialogs',
-          closable: true,
+          closable: false,
         })],
       }, null, 'float');
     }
   }
 
+  static isTabOpen(docker, panelId) {
+    return Boolean(docker.find(panelId));
+  }
+
   static openTab(docker, panelData, refTabId, direction, forceRerender=false) {
     let panel = docker.find(panelData.id);
     if(panel) {
@@ -149,31 +205,110 @@ export class LayoutHelper {
   }
 }
 
-export default function Layout({groups, layoutInstance, ...props}) {
+function saveLayout(layoutObj, layoutId) {
+  let api = getApiInstance();
+  if(!layoutId || !layoutObj) {
+    return;
+  }
+  const formData = new FormData();
+  formData.append('setting', layoutId);
+  formData.append('value', JSON.stringify(layoutObj.saveLayout()));
+  api.post(url_for('settings.store_bulk'), formData)
+    .catch(()=>{/* No need to throw error */});
+}
+
+function getDialogsGroup() {
+  return {
+    disableDock: true,
+    tabLocked: true,
+    floatable: 'singleTab',
+    panelExtra: (panelData, context) => (
+      <div>
+        <PgIconButton title={gettext('Close')} icon={<CloseIcon  />} size="xs" noBorder onClick={()=>{
+          context.dockMove(panelData, null, 'remove');
+        }} />
+      </div>
+    )
+  };
+}
+
+function getDefaultGroup() {
+  return {
+    maximizable: false,
+    panelExtra: (panelData, context) => {
+      let icon = <ExpandDialogIcon style={{width: '0.7em'}}/>;
+      let title = gettext('Maximise');
+      if(panelData?.parent?.mode == 'maximize') {
+        icon = <MinimizeDialogIcon />;
+        title = gettext('Restore');
+      }
+      return <div>
+        <PgIconButton title={title} icon={icon} size="xs" noBorder onClick={()=>{
+          context.dockMove(panelData, null, 'maximize');
+        }} />
+      </div>;
+    }
+  };
+}
+
+export default function Layout({groups, getLayoutInstance, layoutId, savedLayout, ...props}) {
   const classes = useStyles();
+  const layoutObj = useRef();
   const defaultGroups = React.useMemo(()=>({
-    'dialogs': {
-      disableDock: true,
-      tabLocked: true,
-      floatable: 'singleTab',
-    },
+    'dialogs': getDialogsGroup(),
+    'default': getDefaultGroup(),
     ...groups,
   }), [groups]);
-  return (
+
+  const layoutEventBus = React.useRef(new EventBus());
+  return useMemo(()=>(
     <div className={classes.docklayout}>
-      <DockLayout
-        style={{
-          height: '100%',
-        }}
-        ref={layoutInstance}
-        groups={defaultGroups}
-        {...props}
-      />
+      <LayoutEventsContext.Provider value={layoutEventBus.current}>
+        <DockLayout
+          style={{
+            height: '100%',
+          }}
+          ref={(obj)=>{
+            layoutObj.current = obj;
+            if(layoutObj.current) {
+              layoutObj.current.resetLayout = ()=>{
+                layoutObj.current.loadLayout(props.defaultLayout);
+                saveLayout(layoutObj.current, layoutId);
+              };
+            }
+            getLayoutInstance?.(layoutObj.current);
+            try {
+              layoutObj.current?.loadLayout(JSON.parse(savedLayout));
+            } catch {
+              /* Fallback to default */
+              layoutObj.current?.loadLayout(props.defaultLayout);
+            }
+          }}
+          groups={defaultGroups}
+          onLayoutChange={(_l, currentTabId, direction)=>{
+            saveLayout(layoutObj.current, layoutId);
+            if(Object.values(LAYOUT_EVENTS).indexOf(direction) > -1) {
+              layoutEventBus.current.fireEvent(LAYOUT_EVENTS[direction.toUpperCase()], currentTabId);
+            }
+          }}
+          {...props}
+        />
+      </LayoutEventsContext.Provider>
     </div>
-  );
+  ), []);
 }
 
 Layout.propTypes = {
   groups: PropTypes.object,
-  layoutInstance: CustomPropTypes.ref,
+  getLayoutInstance: PropTypes.func,
+};
+
+
+export const LAYOUT_EVENTS = {
+  ACTIVE: 'active',
+  REMOVE: 'remove',
+  FLOAT: 'float',
+  FRONT: 'front',
+  MAXIMIZE: 'maximize',
+  MOVE: 'move',
 };
diff --git a/web/pgadmin/static/js/helpers/ModalProvider.jsx b/web/pgadmin/static/js/helpers/ModalProvider.jsx
index 1f6d07433..f51f69568 100644
--- a/web/pgadmin/static/js/helpers/ModalProvider.jsx
+++ b/web/pgadmin/static/js/helpers/ModalProvider.jsx
@@ -209,7 +209,7 @@ PaperComponent.propTypes = {
   height: PropTypes.number,
 };
 
-const useModalStyles = makeStyles(() => ({
+export const useModalStyles = makeStyles((theme) => ({
   titleBar: {
     display: 'flex',
     flexGrow: 1
@@ -227,9 +227,18 @@ const useModalStyles = makeStyles(() => ({
     flexShrink: 0,
     userSelect: 'none',
   },
+  footer: {
+    display: 'flex',
+    justifyContent: 'flex-end',
+    padding: '0.5rem',
+    ...theme.mixins.panelBorder?.top,
+  },
+  margin: {
+    marginLeft: '0.25rem',
+  },
   iconButtonStyle: {
     marginLeft: 'auto',
-    marginRight: '0.3em'
+    marginRight: '4px'
   }
 }));
 
